/**
 * Apm Configuration API
 * An API for the APM Configuration service. Use this API to query and set APM configuration.
 * OpenAPI spec version: 20210201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The set of Apdex rules to be used in Apdex computation. In the current version, only one rule set may exist per
 * configuration, and attempting to create a rule set if it already exists will result in an error. This may change
 * in future releases.
 *
 */
export interface CreateApdexRulesDetails extends model.CreateConfigDetails {
    "rules": Array<model.Apdex>;
    /**
     * The name by which this rule set can be displayed to the user.
     */
    "displayName": string;
    "configType": string;
}
export declare namespace CreateApdexRulesDetails {
    function getJsonObj(obj: CreateApdexRulesDetails, isParentJsonObj?: boolean): object;
    const configType = "APDEX";
    function getDeserializedJsonObj(obj: CreateApdexRulesDetails, isParentJsonObj?: boolean): object;
}
