/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details to create an Autonomous Data Guard association for an existing Autonomous Database where the standby is in a different (remote) region from the source primary database.
 * The following parameters are required for the cross-region standby database and must contain the same values as the source Autonomous Database:
 *   - dbName
 *   - cpuCoreCount
 *   - dataStorageSizeInTB
 *   - dbVersion
 * The following parameters are optional for the cross-region standby database. If included in the request, these parameters contain the same values as the source Autonomous Database:
 *   - customerContacts
 *   - scheduledOperations
 *   - isAutoScalingForStorageEnabled
 *   - definedTags
 *   - freeformTags
 *   - licenseModel
 *   - whitelistedIps
 *   - isMtlsConnectionRequired
 * Example I - Creating a cross-region standby with required parameters only:
 *     {
 *       \"compartmentId\": \"ocid.compartment.oc1..<var>&lt;unique_ID&gt;</var>\",
 *       \"cpuCoreCount\": 1,
 *       \"dbName\": \"adatabasedb1\",
 *       \"sourceId\": \"ocid1.autonomousdatabase.oc1.phx..<var>&lt;unique_ID&gt;</var>\",
 *       \"dataStorageSizeInTBs\": 1,
 *       \"source\": \"CROSS_REGION_DATAGUARD\",
 *       \"adminPassword\" : \"<var>&lt;password&gt;</var>\",
 *     }
 *  Example II - Creating a cross-region standby that specifies optional parameters in addition to the required parameters:
 *     {
 *       \"compartmentId\": \"ocid.compartment.oc1..<var>&lt;unique_ID&gt;</var>\",
 *       \"cpuCoreCount\": 1,
 *       \"dbName\": \"adatabasedb1\",
 *       \"sourceId\": \"ocid1.autonomousdatabase.oc1.phx..<var>&lt;unique_ID&gt;</var>\",
 *       \"dataStorageSizeInTBs\": 1,
 *       \"source\": \"CROSS_REGION_DATAGUARD\",
 *   \"adminPassword\" : \"<var>&lt;password&gt;</var>\",
 *       \"dbVersion\": \"19c\",
 *       \"licenseModel\": \"LICENSE_INCLUDED\",
 *       \"isAutoScalingForStorageEnabled\": \"true\"
 *     }
 *
 */
export interface CreateCrossRegionAutonomousDatabaseDataGuardDetails extends model.CreateAutonomousDatabaseBase {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the source Autonomous Database that will be used to create a new standby database for the Data Guard association.
     */
    "sourceId": string;
    "source": string;
}
export declare namespace CreateCrossRegionAutonomousDatabaseDataGuardDetails {
    function getJsonObj(obj: CreateCrossRegionAutonomousDatabaseDataGuardDetails, isParentJsonObj?: boolean): object;
    const source = "CROSS_REGION_DATAGUARD";
    function getDeserializedJsonObj(obj: CreateCrossRegionAutonomousDatabaseDataGuardDetails, isParentJsonObj?: boolean): object;
}
