/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Summary of consumerGroupPrivileges.
 */
export interface ConsumerGroupPrivilegeSummary {
    /**
     * The name of granted consumer group.
     */
    "name"?: string;
    /**
     * Indicates whether the grant was with the GRANT option (YES) or not (NO).
     */
    "grantOption"?: ConsumerGroupPrivilegeSummary.GrantOption;
    /**
     * Indicates whether the consumer group is designated as the default for this user or role (YES) or not (NO)
     */
    "initialGroup"?: ConsumerGroupPrivilegeSummary.InitialGroup;
}
export declare namespace ConsumerGroupPrivilegeSummary {
    enum GrantOption {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum InitialGroup {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ConsumerGroupPrivilegeSummary): object;
    function getDeserializedJsonObj(obj: ConsumerGroupPrivilegeSummary): object;
}
