/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Summary of each role.
 */
export interface RoleSummary {
    /**
     * The name of a granted role
     */
    "name"?: string;
    /**
     * Indicates whether the grant was with the ADMIN OPTION (YES) or not (NO)
     */
    "adminOption"?: RoleSummary.AdminOption;
    /**
     * Indicates whether the grant was with the DELEGATE OPTION (YES) or not (NO)
     */
    "delegateOption"?: RoleSummary.DelegateOption;
    /**
     * Indicates whether the role is designated as a DEFAULT ROLE for the user (YES) or not (NO)
     */
    "defaultRole"?: RoleSummary.DefaultRole;
    /**
     * Indicates how the grant was made. Possible values:
     * YES if the role was granted commonly (CONTAINER=ALL was used)
     * NO if the role was granted locally (CONTAINER=ALL was not used)
     *
     */
    "common"?: RoleSummary.Common;
    /**
     * Indicates whether the role grant was inherited from another container (YES) or not (NO)
     */
    "inherited"?: RoleSummary.Inherited;
}
export declare namespace RoleSummary {
    enum AdminOption {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum DelegateOption {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum DefaultRole {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum Common {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum Inherited {
        Yes = "YES",
        No = "NO",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: RoleSummary): object;
    function getDeserializedJsonObj(obj: RoleSummary): object;
}
