/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * SQL Tuning advisor task general info.
 */
export interface SqlTuningAdvisorTaskSummaryReportTaskInfo {
    /**
     * The SQL Tuning Advisor task id. It is not the [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm). Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "id": number;
    /**
     * The SQL Tuning Advisor task name.
     */
    "name": string;
    /**
     * The SQL Tuning Advisor task description. Not defined on Auto SQL Tuning tasks.
     */
    "description"?: string;
    /**
     * The SQL Tuning Advisor task user owner.
     */
    "owner": string;
    /**
     * The SQL Tuning Advisor task status. Not defined on Auto SQL Tuning tasks.
     */
    "status"?: model.SqlTuningTaskStatusTypes;
    /**
     * Start timestamp of task execution.
     */
    "timeStarted": Date;
    /**
     * End timestamp of task execution.
     */
    "timeEnded": Date;
    /**
     * The total running time in seconds. Not defined on Auto SQL Tuning tasks. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "runningTime"?: number;
}
export declare namespace SqlTuningAdvisorTaskSummaryReportTaskInfo {
    function getJsonObj(obj: SqlTuningAdvisorTaskSummaryReportTaskInfo): object;
    function getDeserializedJsonObj(obj: SqlTuningAdvisorTaskSummaryReportTaskInfo): object;
}
