/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The summary of a specific User.
 */
export interface UserSummary {
    /**
     * The name of the User.
     */
    "name": string;
    /**
     * The account status of the User
     */
    "status": UserSummary.Status;
    /**
     * The date of expiration of the account
     */
    "timeExpiring"?: Date;
    /**
     * The default tablespace for data.
     */
    "defaultTablespace": string;
    /**
     * The name of the default tablespace for temporary tables or the name of a tablespace group.
     */
    "tempTablespace": string;
    /**
     * The User creation date.
     */
    "timeCreated": Date;
    /**
     * The User resource profile name.
     */
    "profile": string;
}
export declare namespace UserSummary {
    enum Status {
        Open = "OPEN",
        Expired = "EXPIRED",
        ExpiredGrace = "EXPIRED_GRACE",
        Locked = "LOCKED",
        LockedTimed = "LOCKED_TIMED",
        ExpiredAndLocked = "EXPIRED_AND_LOCKED",
        ExpiredGraceAndLocked = "EXPIRED_GRACE_AND_LOCKED",
        ExpiredAndLockedTimed = "EXPIRED_AND_LOCKED_TIMED",
        ExpiredGraceAndLockedTimed = "EXPIRED_GRACE_AND_LOCKED_TIMED",
        OpenAndInRollover = "OPEN_AND_IN_ROLLOVER",
        ExpiredAndInRollover = "EXPIRED_AND_IN_ROLLOVER",
        LockedAndInRollover = "LOCKED_AND_IN_ROLLOVER",
        ExpiredAndLockedAndInRollover = "EXPIRED_AND_LOCKED_AND_IN_ROLLOVER",
        LockedTimedAndInRollover = "LOCKED_TIMED_AND_IN_ROLLOVER",
        ExpiredAndLockedTimedAndInRol = "EXPIRED_AND_LOCKED_TIMED_AND_IN_ROL",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: UserSummary): object;
    function getDeserializedJsonObj(obj: UserSummary): object;
}
