/**
 * Identity and Access Management Service API
 * APIs for managing users, groups, compartments, and policies.
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * As the name suggests, an `DbCredentialSummary` object contains information about an `DbCredential`.
 * The DB credential is used for DB authentication with
 * the [DB Service].
 *
 */
export interface DbCredentialSummary {
    /**
     * The OCID of the DB credential.
     */
    "id"?: string;
    /**
     * The OCID of the user the DB credential belongs to.
     */
    "userId"?: string;
    /**
     * The description you assign to the DB credential. Does not have to be unique, and it's changeable.
     */
    "description"?: string;
    /**
      * Date and time the `DbCredential` object was created, in the format defined by RFC3339.
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeCreated"?: Date;
    /**
      * Date and time when this credential will expire, in the format defined by RFC3339.
  * Null if it never expires.
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeExpires"?: Date;
    /**
     * The credential's current state. After creating a DB credential, make sure its `lifecycleState` changes from
     * CREATING to ACTIVE before using it.
     *
     */
    "lifecycleState"?: string;
}
export declare namespace DbCredentialSummary {
    function getJsonObj(obj: DbCredentialSummary): object;
    function getDeserializedJsonObj(obj: DbCredentialSummary): object;
}
