/**
 * Identity Service
 * API for the Identity Dataplane
 * OpenAPI spec version: v1
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface User {
    /**
     * The user's Oracle ID (OCID).
     */
    "id": string;
    /**
     * The name of the user.
     */
    "name": string;
    /**
     * If the provided password is a one-time password.
     */
    "isOTP": boolean;
    /**
     * If mfa is activated.
     */
    "isMfaActivated": boolean;
    /**
     * If the user has been mfa verified.
     */
    "isMfaVerified": boolean;
}
export declare namespace User {
    function getJsonObj(obj: User): object;
    function getDeserializedJsonObj(obj: User): object;
}
