"use strict";
/**
 * Operations Insights API
 * Use the Operations Insights API to perform data extraction operations to obtain database
resource utilization, performance statistics, and reference information. For more information,
see [About Oracle Cloud Infrastructure Operations Insights](https://docs.cloud.oracle.com/en-us/iaas/operations-insights/doc/operations-insights.html).

 * OpenAPI spec version: 20200630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExadataDetails = exports.ExadataConfigurationSummary = exports.ExadataConfigurationCollection = exports.EnterpriseManagerBridges = exports.EnterpriseManagerBridgeSummary = exports.EnterpriseManagerBridgeCollection = exports.EnterpriseManagerBridge = exports.EnableHostInsightDetails = exports.EnableExadataInsightDetails = exports.EnableDatabaseInsightDetails = exports.DownloadOperationsInsightsWarehouseWalletDetails = exports.DiskGroupDetails = exports.DiskGroup = exports.DatabaseInsightsCollection = exports.DatabaseInsights = exports.DatabaseInsightSummary = exports.DatabaseInsight = exports.DatabaseEntitySourceAll = exports.DatabaseEntitySource = exports.DatabaseDetails = exports.DatabaseConfigurationSummary = exports.DatabaseConfigurationMetricGroup = exports.DatabaseConfigurationCollection = exports.Database = exports.CredentialDetails = exports.CreateOperationsInsightsWarehouseUserDetails = exports.CreateOperationsInsightsWarehouseDetails = exports.CreateHostInsightDetails = exports.CreateExadataInsightDetails = exports.CreateEnterpriseManagerBridgeDetails = exports.CreateEmManagedExternalExadataMemberEntityDetails = exports.CreateDatabaseInsightDetails = exports.CreateAwrHubDetails = exports.ConnectionDetails = exports.ChangeHostInsightCompartmentDetails = exports.ChangeExadataInsightCompartmentDetails = exports.ChangeEnterpriseManagerBridgeCompartmentDetails = exports.ChangeDatabaseInsightCompartmentDetails = exports.AwrSourceSummary = exports.AwrSnapshotSummary = exports.AwrSnapshotCollection = exports.AwrReportFormatType = exports.AwrReport = exports.AwrHubs = exports.AwrHubSummaryCollection = exports.AwrHubSummary = exports.AwrHubLifecycleState = exports.AwrHub = exports.AddExadataInsightMembersDetails = exports.ActionType = void 0;
exports.IngestSqlStatsDetails = exports.IngestSqlPlanLinesResponseDetails = exports.IngestSqlPlanLinesDetails = exports.IngestSqlBucketResponseDetails = exports.IngestSqlBucketDetails = exports.IngestHostMetricsResponseDetails = exports.IngestHostMetricsDetails = exports.IngestHostConfigurationResponseDetails = exports.IngestHostConfigurationDetails = exports.IngestDatabaseConfigurationResponseDetails = exports.IngestDatabaseConfigurationDetails = exports.ImportableEnterpriseManagerEntityCollection = exports.ImportableEnterpriseManagerEntity = exports.ImportableAgentEntitySummaryCollection = exports.ImportableAgentEntitySummary = exports.ImportableAgentEntitySource = exports.HostedEntitySummary = exports.HostedEntityCollection = exports.HostResourceStatistics = exports.HostResourceCapacityTrendAggregation = exports.HostPerformanceMetricGroup = exports.HostInstanceMap = exports.HostInsights = exports.HostInsightSummaryCollection = exports.HostInsightSummary = exports.HostInsightResourceStatisticsAggregation = exports.HostInsight = exports.HostEntitySource = exports.HostDetails = exports.HostConfigurationSummary = exports.HostConfigurationMetricGroup = exports.HostConfigurationCollection = exports.Host = exports.HistoricalDataItem = exports.ExadataType = exports.ExadataRackType = exports.ExadataMemberSummary = exports.ExadataMemberCollection = exports.ExadataInsights = exports.ExadataInsightSummaryCollection = exports.ExadataInsightSummary = exports.ExadataInsightResourceStatisticsAggregation = exports.ExadataInsightResourceStatistics = exports.ExadataInsightResourceInsightUtilizationItem = exports.ExadataInsightResourceForecastTrendSummary = exports.ExadataInsightResourceCapacityTrendSummary = exports.ExadataInsightResourceCapacityTrendAggregation = exports.ExadataInsightLifecycleState = exports.ExadataInsight = exports.ExadataEntitySource = void 0;
exports.SqlStatisticsTimeSeriesByPlanAggregation = exports.SqlStatisticsTimeSeriesAggregationCollection = exports.SqlStatisticsTimeSeriesAggregation = exports.SqlStatisticsTimeSeries = exports.SqlStatistics = exports.SqlStatisticAggregationCollection = exports.SqlStatisticAggregation = exports.SqlSearchSummary = exports.SqlSearchCollection = exports.SqlResponseTimeDistributionAggregationCollection = exports.SqlResponseTimeDistributionAggregation = exports.SqlPlanSummary = exports.SqlPlanLine = exports.SqlPlanInsights = exports.SqlPlanInsightAggregationCollection = exports.SqlPlanInsightAggregation = exports.SqlPlanCollection = exports.SqlInventory = exports.SqlInsightThresholds = exports.SqlInsightAggregationCollection = exports.SqlInsightAggregation = exports.SqlBucket = exports.SortOrder = exports.ResourceUsageTrendAggregation = exports.ResourceUsageSummary = exports.ResourceStatus = exports.ResourceStatisticsAggregation = exports.ResourceStatistics = exports.ResourceInsightProjectedUtilizationItem = exports.ResourceInsightProjectedUtilization = exports.ResourceInsightCurrentUtilization = exports.ResourceCapacityTrendAggregation = exports.ProjectedDataItem = exports.OperationsInsightsWarehouses = exports.OperationsInsightsWarehouseUsers = exports.OperationsInsightsWarehouseUserSummaryCollection = exports.OperationsInsightsWarehouseUserSummary = exports.OperationsInsightsWarehouseUserLifecycleState = exports.OperationsInsightsWarehouseUser = exports.OperationsInsightsWarehouseSummaryCollection = exports.OperationsInsightsWarehouseSummary = exports.OperationsInsightsWarehouseLifecycleState = exports.OperationsInsightsWarehouse = exports.OperationType = exports.OperationStatus = exports.LifecycleState = exports.InstanceMetrics = exports.IngestSqlTextResponseDetails = exports.IngestSqlTextDetails = exports.IngestSqlStatsResponseDetails = void 0;
exports.WorkRequests = exports.WorkRequestResourceMetadataKey = exports.WorkRequestResource = exports.WorkRequestLogEntryCollection = exports.WorkRequestLogEntry = exports.WorkRequestErrorCollection = exports.WorkRequestError = exports.WorkRequestCollection = exports.WorkRequest = exports.UsageUnit = exports.UpdateOperationsInsightsWarehouseUserDetails = exports.UpdateOperationsInsightsWarehouseDetails = exports.UpdateHostInsightDetails = exports.UpdateExadataInsightDetails = exports.UpdateEnterpriseManagerBridgeDetails = exports.UpdateDatabaseInsightDetails = exports.UpdateAwrHubDetails = exports.TablespaceUsageTrendAggregation = exports.TablespaceUsageTrend = exports.SummaryStatistics = exports.SummarizeOperationsInsightsWarehouseResourceUsageAggregation = exports.SummarizeHostInsightResourceUtilizationInsightAggregation = exports.SummarizeHostInsightResourceUsageTrendAggregationCollection = exports.SummarizeHostInsightResourceUsageAggregation = exports.SummarizeHostInsightResourceStatisticsAggregationCollection = exports.SummarizeHostInsightResourceForecastTrendAggregation = exports.SummarizeHostInsightResourceCapacityTrendAggregationCollection = exports.SummarizeExadataInsightResourceUtilizationInsightAggregation = exports.SummarizeExadataInsightResourceUsageCollection = exports.SummarizeExadataInsightResourceUsageAggregation = exports.SummarizeExadataInsightResourceStatisticsAggregationCollection = exports.SummarizeExadataInsightResourceForecastTrendCollection = exports.SummarizeExadataInsightResourceForecastTrendAggregation = exports.SummarizeExadataInsightResourceCapacityTrendCollection = exports.SummarizeExadataInsightResourceCapacityTrendAggregation = exports.SummarizeDatabaseInsightTablespaceUsageTrendAggregationCollection = exports.SummarizeDatabaseInsightResourceUtilizationInsightAggregation = exports.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = exports.SummarizeDatabaseInsightResourceUsageAggregation = exports.SummarizeDatabaseInsightResourceStatisticsAggregationCollection = exports.SummarizeDatabaseInsightResourceForecastTrendAggregation = exports.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = exports.SummarizeAwrSourcesSummariesCollection = exports.StorageServerDetails = exports.StorageServer = exports.SqlTextSummary = exports.SqlTextCollection = exports.SqlText = exports.SqlStats = exports.SqlStatisticsTimeSeriesByPlanAggregationCollection = void 0;
exports.UpdateEmManagedExternalDatabaseInsightDetails = exports.UpdateAutonomousDatabaseInsightDetails = exports.MacsManagedExternalHostInsightSummary = exports.MacsManagedExternalHostInsight = exports.MacsManagedExternalHostConfigurationSummary = exports.MacsManagedExternalDatabaseInsightSummary = exports.MacsManagedExternalDatabaseInsight = exports.MacsManagedExternalDatabaseConfigurationSummary = exports.HostResourceAllocation = exports.HostProduct = exports.HostNetworkConfiguration = exports.HostNetworkActivitySummary = exports.HostMemoryUsage = exports.HostMemoryStatistics = exports.HostMemoryConfiguration = exports.HostImportableAgentEntitySummary = exports.HostHardwareConfiguration = exports.HostEntities = exports.HostCpuUsage = exports.HostCpuStatistics = exports.HostCpuHardwareConfiguration = exports.ExadataStorageServerStatisticsSummary = exports.ExadataHostStatisticsSummary = exports.ExadataDiskgroupStatisticsSummary = exports.ExadataDatabaseStatisticsSummary = exports.ExadataDatabaseMachineConfigurationSummary = exports.EnableMacsManagedExternalHostInsightDetails = exports.EnableEmManagedExternalHostInsightDetails = exports.EnableEmManagedExternalExadataInsightDetails = exports.EnableEmManagedExternalDatabaseInsightDetails = exports.EmManagedExternalHostInsightSummary = exports.EmManagedExternalHostInsight = exports.EmManagedExternalHostConfigurationSummary = exports.EmManagedExternalExadataInsightSummary = exports.EmManagedExternalExadataInsight = exports.EmManagedExternalDatabaseInsightSummary = exports.EmManagedExternalDatabaseInsight = exports.EmManagedExternalDatabaseConfigurationSummary = exports.DBOSConfigInstance = exports.DBExternalProperties = exports.DBExternalInstance = exports.CredentialsBySource = exports.CreateMacsManagedExternalHostInsightDetails = exports.CreateEmManagedExternalHostInsightDetails = exports.CreateEmManagedExternalExadataInsightDetails = exports.CreateEmManagedExternalDatabaseInsightDetails = exports.AutonomousDatabaseInsightSummary = exports.AutonomousDatabaseInsight = exports.AutonomousDatabaseConfigurationSummary = exports.AddEmManagedExternalExadataInsightMembersDetails = void 0;
exports.UpdateMacsManagedExternalHostInsightDetails = exports.UpdateMacsManagedExternalDatabaseInsightDetails = exports.UpdateEmManagedExternalHostInsightDetails = exports.UpdateEmManagedExternalExadataInsightDetails = void 0;
const ActionType = __importStar(require("./action-type"));
exports.ActionType = ActionType.ActionType;
const AddExadataInsightMembersDetails = __importStar(require("./add-exadata-insight-members-details"));
exports.AddExadataInsightMembersDetails = AddExadataInsightMembersDetails.AddExadataInsightMembersDetails;
const AwrHub = __importStar(require("./awr-hub"));
exports.AwrHub = AwrHub.AwrHub;
const AwrHubLifecycleState = __importStar(require("./awr-hub-lifecycle-state"));
exports.AwrHubLifecycleState = AwrHubLifecycleState.AwrHubLifecycleState;
const AwrHubSummary = __importStar(require("./awr-hub-summary"));
exports.AwrHubSummary = AwrHubSummary.AwrHubSummary;
const AwrHubSummaryCollection = __importStar(require("./awr-hub-summary-collection"));
exports.AwrHubSummaryCollection = AwrHubSummaryCollection.AwrHubSummaryCollection;
const AwrHubs = __importStar(require("./awr-hubs"));
exports.AwrHubs = AwrHubs.AwrHubs;
const AwrReport = __importStar(require("./awr-report"));
exports.AwrReport = AwrReport.AwrReport;
const AwrReportFormatType = __importStar(require("./awr-report-format-type"));
exports.AwrReportFormatType = AwrReportFormatType.AwrReportFormatType;
const AwrSnapshotCollection = __importStar(require("./awr-snapshot-collection"));
exports.AwrSnapshotCollection = AwrSnapshotCollection.AwrSnapshotCollection;
const AwrSnapshotSummary = __importStar(require("./awr-snapshot-summary"));
exports.AwrSnapshotSummary = AwrSnapshotSummary.AwrSnapshotSummary;
const AwrSourceSummary = __importStar(require("./awr-source-summary"));
exports.AwrSourceSummary = AwrSourceSummary.AwrSourceSummary;
const ChangeDatabaseInsightCompartmentDetails = __importStar(require("./change-database-insight-compartment-details"));
exports.ChangeDatabaseInsightCompartmentDetails = ChangeDatabaseInsightCompartmentDetails.ChangeDatabaseInsightCompartmentDetails;
const ChangeEnterpriseManagerBridgeCompartmentDetails = __importStar(require("./change-enterprise-manager-bridge-compartment-details"));
exports.ChangeEnterpriseManagerBridgeCompartmentDetails = ChangeEnterpriseManagerBridgeCompartmentDetails.ChangeEnterpriseManagerBridgeCompartmentDetails;
const ChangeExadataInsightCompartmentDetails = __importStar(require("./change-exadata-insight-compartment-details"));
exports.ChangeExadataInsightCompartmentDetails = ChangeExadataInsightCompartmentDetails.ChangeExadataInsightCompartmentDetails;
const ChangeHostInsightCompartmentDetails = __importStar(require("./change-host-insight-compartment-details"));
exports.ChangeHostInsightCompartmentDetails = ChangeHostInsightCompartmentDetails.ChangeHostInsightCompartmentDetails;
const ConnectionDetails = __importStar(require("./connection-details"));
exports.ConnectionDetails = ConnectionDetails.ConnectionDetails;
const CreateAwrHubDetails = __importStar(require("./create-awr-hub-details"));
exports.CreateAwrHubDetails = CreateAwrHubDetails.CreateAwrHubDetails;
const CreateDatabaseInsightDetails = __importStar(require("./create-database-insight-details"));
exports.CreateDatabaseInsightDetails = CreateDatabaseInsightDetails.CreateDatabaseInsightDetails;
const CreateEmManagedExternalExadataMemberEntityDetails = __importStar(require("./create-em-managed-external-exadata-member-entity-details"));
exports.CreateEmManagedExternalExadataMemberEntityDetails = CreateEmManagedExternalExadataMemberEntityDetails.CreateEmManagedExternalExadataMemberEntityDetails;
const CreateEnterpriseManagerBridgeDetails = __importStar(require("./create-enterprise-manager-bridge-details"));
exports.CreateEnterpriseManagerBridgeDetails = CreateEnterpriseManagerBridgeDetails.CreateEnterpriseManagerBridgeDetails;
const CreateExadataInsightDetails = __importStar(require("./create-exadata-insight-details"));
exports.CreateExadataInsightDetails = CreateExadataInsightDetails.CreateExadataInsightDetails;
const CreateHostInsightDetails = __importStar(require("./create-host-insight-details"));
exports.CreateHostInsightDetails = CreateHostInsightDetails.CreateHostInsightDetails;
const CreateOperationsInsightsWarehouseDetails = __importStar(require("./create-operations-insights-warehouse-details"));
exports.CreateOperationsInsightsWarehouseDetails = CreateOperationsInsightsWarehouseDetails.CreateOperationsInsightsWarehouseDetails;
const CreateOperationsInsightsWarehouseUserDetails = __importStar(require("./create-operations-insights-warehouse-user-details"));
exports.CreateOperationsInsightsWarehouseUserDetails = CreateOperationsInsightsWarehouseUserDetails.CreateOperationsInsightsWarehouseUserDetails;
const CredentialDetails = __importStar(require("./credential-details"));
exports.CredentialDetails = CredentialDetails.CredentialDetails;
const Database = __importStar(require("./database"));
exports.Database = Database.Database;
const DatabaseConfigurationCollection = __importStar(require("./database-configuration-collection"));
exports.DatabaseConfigurationCollection = DatabaseConfigurationCollection.DatabaseConfigurationCollection;
const DatabaseConfigurationMetricGroup = __importStar(require("./database-configuration-metric-group"));
exports.DatabaseConfigurationMetricGroup = DatabaseConfigurationMetricGroup.DatabaseConfigurationMetricGroup;
const DatabaseConfigurationSummary = __importStar(require("./database-configuration-summary"));
exports.DatabaseConfigurationSummary = DatabaseConfigurationSummary.DatabaseConfigurationSummary;
const DatabaseDetails = __importStar(require("./database-details"));
exports.DatabaseDetails = DatabaseDetails.DatabaseDetails;
const DatabaseEntitySource = __importStar(require("./database-entity-source"));
exports.DatabaseEntitySource = DatabaseEntitySource.DatabaseEntitySource;
const DatabaseEntitySourceAll = __importStar(require("./database-entity-source-all"));
exports.DatabaseEntitySourceAll = DatabaseEntitySourceAll.DatabaseEntitySourceAll;
const DatabaseInsight = __importStar(require("./database-insight"));
exports.DatabaseInsight = DatabaseInsight.DatabaseInsight;
const DatabaseInsightSummary = __importStar(require("./database-insight-summary"));
exports.DatabaseInsightSummary = DatabaseInsightSummary.DatabaseInsightSummary;
const DatabaseInsights = __importStar(require("./database-insights"));
exports.DatabaseInsights = DatabaseInsights.DatabaseInsights;
const DatabaseInsightsCollection = __importStar(require("./database-insights-collection"));
exports.DatabaseInsightsCollection = DatabaseInsightsCollection.DatabaseInsightsCollection;
const DiskGroup = __importStar(require("./disk-group"));
exports.DiskGroup = DiskGroup.DiskGroup;
const DiskGroupDetails = __importStar(require("./disk-group-details"));
exports.DiskGroupDetails = DiskGroupDetails.DiskGroupDetails;
const DownloadOperationsInsightsWarehouseWalletDetails = __importStar(require("./download-operations-insights-warehouse-wallet-details"));
exports.DownloadOperationsInsightsWarehouseWalletDetails = DownloadOperationsInsightsWarehouseWalletDetails.DownloadOperationsInsightsWarehouseWalletDetails;
const EnableDatabaseInsightDetails = __importStar(require("./enable-database-insight-details"));
exports.EnableDatabaseInsightDetails = EnableDatabaseInsightDetails.EnableDatabaseInsightDetails;
const EnableExadataInsightDetails = __importStar(require("./enable-exadata-insight-details"));
exports.EnableExadataInsightDetails = EnableExadataInsightDetails.EnableExadataInsightDetails;
const EnableHostInsightDetails = __importStar(require("./enable-host-insight-details"));
exports.EnableHostInsightDetails = EnableHostInsightDetails.EnableHostInsightDetails;
const EnterpriseManagerBridge = __importStar(require("./enterprise-manager-bridge"));
exports.EnterpriseManagerBridge = EnterpriseManagerBridge.EnterpriseManagerBridge;
const EnterpriseManagerBridgeCollection = __importStar(require("./enterprise-manager-bridge-collection"));
exports.EnterpriseManagerBridgeCollection = EnterpriseManagerBridgeCollection.EnterpriseManagerBridgeCollection;
const EnterpriseManagerBridgeSummary = __importStar(require("./enterprise-manager-bridge-summary"));
exports.EnterpriseManagerBridgeSummary = EnterpriseManagerBridgeSummary.EnterpriseManagerBridgeSummary;
const EnterpriseManagerBridges = __importStar(require("./enterprise-manager-bridges"));
exports.EnterpriseManagerBridges = EnterpriseManagerBridges.EnterpriseManagerBridges;
const ExadataConfigurationCollection = __importStar(require("./exadata-configuration-collection"));
exports.ExadataConfigurationCollection = ExadataConfigurationCollection.ExadataConfigurationCollection;
const ExadataConfigurationSummary = __importStar(require("./exadata-configuration-summary"));
exports.ExadataConfigurationSummary = ExadataConfigurationSummary.ExadataConfigurationSummary;
const ExadataDetails = __importStar(require("./exadata-details"));
exports.ExadataDetails = ExadataDetails.ExadataDetails;
const ExadataEntitySource = __importStar(require("./exadata-entity-source"));
exports.ExadataEntitySource = ExadataEntitySource.ExadataEntitySource;
const ExadataInsight = __importStar(require("./exadata-insight"));
exports.ExadataInsight = ExadataInsight.ExadataInsight;
const ExadataInsightLifecycleState = __importStar(require("./exadata-insight-lifecycle-state"));
exports.ExadataInsightLifecycleState = ExadataInsightLifecycleState.ExadataInsightLifecycleState;
const ExadataInsightResourceCapacityTrendAggregation = __importStar(require("./exadata-insight-resource-capacity-trend-aggregation"));
exports.ExadataInsightResourceCapacityTrendAggregation = ExadataInsightResourceCapacityTrendAggregation.ExadataInsightResourceCapacityTrendAggregation;
const ExadataInsightResourceCapacityTrendSummary = __importStar(require("./exadata-insight-resource-capacity-trend-summary"));
exports.ExadataInsightResourceCapacityTrendSummary = ExadataInsightResourceCapacityTrendSummary.ExadataInsightResourceCapacityTrendSummary;
const ExadataInsightResourceForecastTrendSummary = __importStar(require("./exadata-insight-resource-forecast-trend-summary"));
exports.ExadataInsightResourceForecastTrendSummary = ExadataInsightResourceForecastTrendSummary.ExadataInsightResourceForecastTrendSummary;
const ExadataInsightResourceInsightUtilizationItem = __importStar(require("./exadata-insight-resource-insight-utilization-item"));
exports.ExadataInsightResourceInsightUtilizationItem = ExadataInsightResourceInsightUtilizationItem.ExadataInsightResourceInsightUtilizationItem;
const ExadataInsightResourceStatistics = __importStar(require("./exadata-insight-resource-statistics"));
exports.ExadataInsightResourceStatistics = ExadataInsightResourceStatistics.ExadataInsightResourceStatistics;
const ExadataInsightResourceStatisticsAggregation = __importStar(require("./exadata-insight-resource-statistics-aggregation"));
exports.ExadataInsightResourceStatisticsAggregation = ExadataInsightResourceStatisticsAggregation.ExadataInsightResourceStatisticsAggregation;
const ExadataInsightSummary = __importStar(require("./exadata-insight-summary"));
exports.ExadataInsightSummary = ExadataInsightSummary.ExadataInsightSummary;
const ExadataInsightSummaryCollection = __importStar(require("./exadata-insight-summary-collection"));
exports.ExadataInsightSummaryCollection = ExadataInsightSummaryCollection.ExadataInsightSummaryCollection;
const ExadataInsights = __importStar(require("./exadata-insights"));
exports.ExadataInsights = ExadataInsights.ExadataInsights;
const ExadataMemberCollection = __importStar(require("./exadata-member-collection"));
exports.ExadataMemberCollection = ExadataMemberCollection.ExadataMemberCollection;
const ExadataMemberSummary = __importStar(require("./exadata-member-summary"));
exports.ExadataMemberSummary = ExadataMemberSummary.ExadataMemberSummary;
const ExadataRackType = __importStar(require("./exadata-rack-type"));
exports.ExadataRackType = ExadataRackType.ExadataRackType;
const ExadataType = __importStar(require("./exadata-type"));
exports.ExadataType = ExadataType.ExadataType;
const HistoricalDataItem = __importStar(require("./historical-data-item"));
exports.HistoricalDataItem = HistoricalDataItem.HistoricalDataItem;
const Host = __importStar(require("./host"));
exports.Host = Host.Host;
const HostConfigurationCollection = __importStar(require("./host-configuration-collection"));
exports.HostConfigurationCollection = HostConfigurationCollection.HostConfigurationCollection;
const HostConfigurationMetricGroup = __importStar(require("./host-configuration-metric-group"));
exports.HostConfigurationMetricGroup = HostConfigurationMetricGroup.HostConfigurationMetricGroup;
const HostConfigurationSummary = __importStar(require("./host-configuration-summary"));
exports.HostConfigurationSummary = HostConfigurationSummary.HostConfigurationSummary;
const HostDetails = __importStar(require("./host-details"));
exports.HostDetails = HostDetails.HostDetails;
const HostEntitySource = __importStar(require("./host-entity-source"));
exports.HostEntitySource = HostEntitySource.HostEntitySource;
const HostInsight = __importStar(require("./host-insight"));
exports.HostInsight = HostInsight.HostInsight;
const HostInsightResourceStatisticsAggregation = __importStar(require("./host-insight-resource-statistics-aggregation"));
exports.HostInsightResourceStatisticsAggregation = HostInsightResourceStatisticsAggregation.HostInsightResourceStatisticsAggregation;
const HostInsightSummary = __importStar(require("./host-insight-summary"));
exports.HostInsightSummary = HostInsightSummary.HostInsightSummary;
const HostInsightSummaryCollection = __importStar(require("./host-insight-summary-collection"));
exports.HostInsightSummaryCollection = HostInsightSummaryCollection.HostInsightSummaryCollection;
const HostInsights = __importStar(require("./host-insights"));
exports.HostInsights = HostInsights.HostInsights;
const HostInstanceMap = __importStar(require("./host-instance-map"));
exports.HostInstanceMap = HostInstanceMap.HostInstanceMap;
const HostPerformanceMetricGroup = __importStar(require("./host-performance-metric-group"));
exports.HostPerformanceMetricGroup = HostPerformanceMetricGroup.HostPerformanceMetricGroup;
const HostResourceCapacityTrendAggregation = __importStar(require("./host-resource-capacity-trend-aggregation"));
exports.HostResourceCapacityTrendAggregation = HostResourceCapacityTrendAggregation.HostResourceCapacityTrendAggregation;
const HostResourceStatistics = __importStar(require("./host-resource-statistics"));
exports.HostResourceStatistics = HostResourceStatistics.HostResourceStatistics;
const HostedEntityCollection = __importStar(require("./hosted-entity-collection"));
exports.HostedEntityCollection = HostedEntityCollection.HostedEntityCollection;
const HostedEntitySummary = __importStar(require("./hosted-entity-summary"));
exports.HostedEntitySummary = HostedEntitySummary.HostedEntitySummary;
const ImportableAgentEntitySource = __importStar(require("./importable-agent-entity-source"));
exports.ImportableAgentEntitySource = ImportableAgentEntitySource.ImportableAgentEntitySource;
const ImportableAgentEntitySummary = __importStar(require("./importable-agent-entity-summary"));
exports.ImportableAgentEntitySummary = ImportableAgentEntitySummary.ImportableAgentEntitySummary;
const ImportableAgentEntitySummaryCollection = __importStar(require("./importable-agent-entity-summary-collection"));
exports.ImportableAgentEntitySummaryCollection = ImportableAgentEntitySummaryCollection.ImportableAgentEntitySummaryCollection;
const ImportableEnterpriseManagerEntity = __importStar(require("./importable-enterprise-manager-entity"));
exports.ImportableEnterpriseManagerEntity = ImportableEnterpriseManagerEntity.ImportableEnterpriseManagerEntity;
const ImportableEnterpriseManagerEntityCollection = __importStar(require("./importable-enterprise-manager-entity-collection"));
exports.ImportableEnterpriseManagerEntityCollection = ImportableEnterpriseManagerEntityCollection.ImportableEnterpriseManagerEntityCollection;
const IngestDatabaseConfigurationDetails = __importStar(require("./ingest-database-configuration-details"));
exports.IngestDatabaseConfigurationDetails = IngestDatabaseConfigurationDetails.IngestDatabaseConfigurationDetails;
const IngestDatabaseConfigurationResponseDetails = __importStar(require("./ingest-database-configuration-response-details"));
exports.IngestDatabaseConfigurationResponseDetails = IngestDatabaseConfigurationResponseDetails.IngestDatabaseConfigurationResponseDetails;
const IngestHostConfigurationDetails = __importStar(require("./ingest-host-configuration-details"));
exports.IngestHostConfigurationDetails = IngestHostConfigurationDetails.IngestHostConfigurationDetails;
const IngestHostConfigurationResponseDetails = __importStar(require("./ingest-host-configuration-response-details"));
exports.IngestHostConfigurationResponseDetails = IngestHostConfigurationResponseDetails.IngestHostConfigurationResponseDetails;
const IngestHostMetricsDetails = __importStar(require("./ingest-host-metrics-details"));
exports.IngestHostMetricsDetails = IngestHostMetricsDetails.IngestHostMetricsDetails;
const IngestHostMetricsResponseDetails = __importStar(require("./ingest-host-metrics-response-details"));
exports.IngestHostMetricsResponseDetails = IngestHostMetricsResponseDetails.IngestHostMetricsResponseDetails;
const IngestSqlBucketDetails = __importStar(require("./ingest-sql-bucket-details"));
exports.IngestSqlBucketDetails = IngestSqlBucketDetails.IngestSqlBucketDetails;
const IngestSqlBucketResponseDetails = __importStar(require("./ingest-sql-bucket-response-details"));
exports.IngestSqlBucketResponseDetails = IngestSqlBucketResponseDetails.IngestSqlBucketResponseDetails;
const IngestSqlPlanLinesDetails = __importStar(require("./ingest-sql-plan-lines-details"));
exports.IngestSqlPlanLinesDetails = IngestSqlPlanLinesDetails.IngestSqlPlanLinesDetails;
const IngestSqlPlanLinesResponseDetails = __importStar(require("./ingest-sql-plan-lines-response-details"));
exports.IngestSqlPlanLinesResponseDetails = IngestSqlPlanLinesResponseDetails.IngestSqlPlanLinesResponseDetails;
const IngestSqlStatsDetails = __importStar(require("./ingest-sql-stats-details"));
exports.IngestSqlStatsDetails = IngestSqlStatsDetails.IngestSqlStatsDetails;
const IngestSqlStatsResponseDetails = __importStar(require("./ingest-sql-stats-response-details"));
exports.IngestSqlStatsResponseDetails = IngestSqlStatsResponseDetails.IngestSqlStatsResponseDetails;
const IngestSqlTextDetails = __importStar(require("./ingest-sql-text-details"));
exports.IngestSqlTextDetails = IngestSqlTextDetails.IngestSqlTextDetails;
const IngestSqlTextResponseDetails = __importStar(require("./ingest-sql-text-response-details"));
exports.IngestSqlTextResponseDetails = IngestSqlTextResponseDetails.IngestSqlTextResponseDetails;
const InstanceMetrics = __importStar(require("./instance-metrics"));
exports.InstanceMetrics = InstanceMetrics.InstanceMetrics;
const LifecycleState = __importStar(require("./lifecycle-state"));
exports.LifecycleState = LifecycleState.LifecycleState;
const OperationStatus = __importStar(require("./operation-status"));
exports.OperationStatus = OperationStatus.OperationStatus;
const OperationType = __importStar(require("./operation-type"));
exports.OperationType = OperationType.OperationType;
const OperationsInsightsWarehouse = __importStar(require("./operations-insights-warehouse"));
exports.OperationsInsightsWarehouse = OperationsInsightsWarehouse.OperationsInsightsWarehouse;
const OperationsInsightsWarehouseLifecycleState = __importStar(require("./operations-insights-warehouse-lifecycle-state"));
exports.OperationsInsightsWarehouseLifecycleState = OperationsInsightsWarehouseLifecycleState.OperationsInsightsWarehouseLifecycleState;
const OperationsInsightsWarehouseSummary = __importStar(require("./operations-insights-warehouse-summary"));
exports.OperationsInsightsWarehouseSummary = OperationsInsightsWarehouseSummary.OperationsInsightsWarehouseSummary;
const OperationsInsightsWarehouseSummaryCollection = __importStar(require("./operations-insights-warehouse-summary-collection"));
exports.OperationsInsightsWarehouseSummaryCollection = OperationsInsightsWarehouseSummaryCollection.OperationsInsightsWarehouseSummaryCollection;
const OperationsInsightsWarehouseUser = __importStar(require("./operations-insights-warehouse-user"));
exports.OperationsInsightsWarehouseUser = OperationsInsightsWarehouseUser.OperationsInsightsWarehouseUser;
const OperationsInsightsWarehouseUserLifecycleState = __importStar(require("./operations-insights-warehouse-user-lifecycle-state"));
exports.OperationsInsightsWarehouseUserLifecycleState = OperationsInsightsWarehouseUserLifecycleState.OperationsInsightsWarehouseUserLifecycleState;
const OperationsInsightsWarehouseUserSummary = __importStar(require("./operations-insights-warehouse-user-summary"));
exports.OperationsInsightsWarehouseUserSummary = OperationsInsightsWarehouseUserSummary.OperationsInsightsWarehouseUserSummary;
const OperationsInsightsWarehouseUserSummaryCollection = __importStar(require("./operations-insights-warehouse-user-summary-collection"));
exports.OperationsInsightsWarehouseUserSummaryCollection = OperationsInsightsWarehouseUserSummaryCollection.OperationsInsightsWarehouseUserSummaryCollection;
const OperationsInsightsWarehouseUsers = __importStar(require("./operations-insights-warehouse-users"));
exports.OperationsInsightsWarehouseUsers = OperationsInsightsWarehouseUsers.OperationsInsightsWarehouseUsers;
const OperationsInsightsWarehouses = __importStar(require("./operations-insights-warehouses"));
exports.OperationsInsightsWarehouses = OperationsInsightsWarehouses.OperationsInsightsWarehouses;
const ProjectedDataItem = __importStar(require("./projected-data-item"));
exports.ProjectedDataItem = ProjectedDataItem.ProjectedDataItem;
const ResourceCapacityTrendAggregation = __importStar(require("./resource-capacity-trend-aggregation"));
exports.ResourceCapacityTrendAggregation = ResourceCapacityTrendAggregation.ResourceCapacityTrendAggregation;
const ResourceInsightCurrentUtilization = __importStar(require("./resource-insight-current-utilization"));
exports.ResourceInsightCurrentUtilization = ResourceInsightCurrentUtilization.ResourceInsightCurrentUtilization;
const ResourceInsightProjectedUtilization = __importStar(require("./resource-insight-projected-utilization"));
exports.ResourceInsightProjectedUtilization = ResourceInsightProjectedUtilization.ResourceInsightProjectedUtilization;
const ResourceInsightProjectedUtilizationItem = __importStar(require("./resource-insight-projected-utilization-item"));
exports.ResourceInsightProjectedUtilizationItem = ResourceInsightProjectedUtilizationItem.ResourceInsightProjectedUtilizationItem;
const ResourceStatistics = __importStar(require("./resource-statistics"));
exports.ResourceStatistics = ResourceStatistics.ResourceStatistics;
const ResourceStatisticsAggregation = __importStar(require("./resource-statistics-aggregation"));
exports.ResourceStatisticsAggregation = ResourceStatisticsAggregation.ResourceStatisticsAggregation;
const ResourceStatus = __importStar(require("./resource-status"));
exports.ResourceStatus = ResourceStatus.ResourceStatus;
const ResourceUsageSummary = __importStar(require("./resource-usage-summary"));
exports.ResourceUsageSummary = ResourceUsageSummary.ResourceUsageSummary;
const ResourceUsageTrendAggregation = __importStar(require("./resource-usage-trend-aggregation"));
exports.ResourceUsageTrendAggregation = ResourceUsageTrendAggregation.ResourceUsageTrendAggregation;
const SortOrder = __importStar(require("./sort-order"));
exports.SortOrder = SortOrder.SortOrder;
const SqlBucket = __importStar(require("./sql-bucket"));
exports.SqlBucket = SqlBucket.SqlBucket;
const SqlInsightAggregation = __importStar(require("./sql-insight-aggregation"));
exports.SqlInsightAggregation = SqlInsightAggregation.SqlInsightAggregation;
const SqlInsightAggregationCollection = __importStar(require("./sql-insight-aggregation-collection"));
exports.SqlInsightAggregationCollection = SqlInsightAggregationCollection.SqlInsightAggregationCollection;
const SqlInsightThresholds = __importStar(require("./sql-insight-thresholds"));
exports.SqlInsightThresholds = SqlInsightThresholds.SqlInsightThresholds;
const SqlInventory = __importStar(require("./sql-inventory"));
exports.SqlInventory = SqlInventory.SqlInventory;
const SqlPlanCollection = __importStar(require("./sql-plan-collection"));
exports.SqlPlanCollection = SqlPlanCollection.SqlPlanCollection;
const SqlPlanInsightAggregation = __importStar(require("./sql-plan-insight-aggregation"));
exports.SqlPlanInsightAggregation = SqlPlanInsightAggregation.SqlPlanInsightAggregation;
const SqlPlanInsightAggregationCollection = __importStar(require("./sql-plan-insight-aggregation-collection"));
exports.SqlPlanInsightAggregationCollection = SqlPlanInsightAggregationCollection.SqlPlanInsightAggregationCollection;
const SqlPlanInsights = __importStar(require("./sql-plan-insights"));
exports.SqlPlanInsights = SqlPlanInsights.SqlPlanInsights;
const SqlPlanLine = __importStar(require("./sql-plan-line"));
exports.SqlPlanLine = SqlPlanLine.SqlPlanLine;
const SqlPlanSummary = __importStar(require("./sql-plan-summary"));
exports.SqlPlanSummary = SqlPlanSummary.SqlPlanSummary;
const SqlResponseTimeDistributionAggregation = __importStar(require("./sql-response-time-distribution-aggregation"));
exports.SqlResponseTimeDistributionAggregation = SqlResponseTimeDistributionAggregation.SqlResponseTimeDistributionAggregation;
const SqlResponseTimeDistributionAggregationCollection = __importStar(require("./sql-response-time-distribution-aggregation-collection"));
exports.SqlResponseTimeDistributionAggregationCollection = SqlResponseTimeDistributionAggregationCollection.SqlResponseTimeDistributionAggregationCollection;
const SqlSearchCollection = __importStar(require("./sql-search-collection"));
exports.SqlSearchCollection = SqlSearchCollection.SqlSearchCollection;
const SqlSearchSummary = __importStar(require("./sql-search-summary"));
exports.SqlSearchSummary = SqlSearchSummary.SqlSearchSummary;
const SqlStatisticAggregation = __importStar(require("./sql-statistic-aggregation"));
exports.SqlStatisticAggregation = SqlStatisticAggregation.SqlStatisticAggregation;
const SqlStatisticAggregationCollection = __importStar(require("./sql-statistic-aggregation-collection"));
exports.SqlStatisticAggregationCollection = SqlStatisticAggregationCollection.SqlStatisticAggregationCollection;
const SqlStatistics = __importStar(require("./sql-statistics"));
exports.SqlStatistics = SqlStatistics.SqlStatistics;
const SqlStatisticsTimeSeries = __importStar(require("./sql-statistics-time-series"));
exports.SqlStatisticsTimeSeries = SqlStatisticsTimeSeries.SqlStatisticsTimeSeries;
const SqlStatisticsTimeSeriesAggregation = __importStar(require("./sql-statistics-time-series-aggregation"));
exports.SqlStatisticsTimeSeriesAggregation = SqlStatisticsTimeSeriesAggregation.SqlStatisticsTimeSeriesAggregation;
const SqlStatisticsTimeSeriesAggregationCollection = __importStar(require("./sql-statistics-time-series-aggregation-collection"));
exports.SqlStatisticsTimeSeriesAggregationCollection = SqlStatisticsTimeSeriesAggregationCollection.SqlStatisticsTimeSeriesAggregationCollection;
const SqlStatisticsTimeSeriesByPlanAggregation = __importStar(require("./sql-statistics-time-series-by-plan-aggregation"));
exports.SqlStatisticsTimeSeriesByPlanAggregation = SqlStatisticsTimeSeriesByPlanAggregation.SqlStatisticsTimeSeriesByPlanAggregation;
const SqlStatisticsTimeSeriesByPlanAggregationCollection = __importStar(require("./sql-statistics-time-series-by-plan-aggregation-collection"));
exports.SqlStatisticsTimeSeriesByPlanAggregationCollection = SqlStatisticsTimeSeriesByPlanAggregationCollection.SqlStatisticsTimeSeriesByPlanAggregationCollection;
const SqlStats = __importStar(require("./sql-stats"));
exports.SqlStats = SqlStats.SqlStats;
const SqlText = __importStar(require("./sql-text"));
exports.SqlText = SqlText.SqlText;
const SqlTextCollection = __importStar(require("./sql-text-collection"));
exports.SqlTextCollection = SqlTextCollection.SqlTextCollection;
const SqlTextSummary = __importStar(require("./sql-text-summary"));
exports.SqlTextSummary = SqlTextSummary.SqlTextSummary;
const StorageServer = __importStar(require("./storage-server"));
exports.StorageServer = StorageServer.StorageServer;
const StorageServerDetails = __importStar(require("./storage-server-details"));
exports.StorageServerDetails = StorageServerDetails.StorageServerDetails;
const SummarizeAwrSourcesSummariesCollection = __importStar(require("./summarize-awr-sources-summaries-collection"));
exports.SummarizeAwrSourcesSummariesCollection = SummarizeAwrSourcesSummariesCollection.SummarizeAwrSourcesSummariesCollection;
const SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = __importStar(require("./summarize-database-insight-resource-capacity-trend-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection;
const SummarizeDatabaseInsightResourceForecastTrendAggregation = __importStar(require("./summarize-database-insight-resource-forecast-trend-aggregation"));
exports.SummarizeDatabaseInsightResourceForecastTrendAggregation = SummarizeDatabaseInsightResourceForecastTrendAggregation.SummarizeDatabaseInsightResourceForecastTrendAggregation;
const SummarizeDatabaseInsightResourceStatisticsAggregationCollection = __importStar(require("./summarize-database-insight-resource-statistics-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceStatisticsAggregationCollection = SummarizeDatabaseInsightResourceStatisticsAggregationCollection.SummarizeDatabaseInsightResourceStatisticsAggregationCollection;
const SummarizeDatabaseInsightResourceUsageAggregation = __importStar(require("./summarize-database-insight-resource-usage-aggregation"));
exports.SummarizeDatabaseInsightResourceUsageAggregation = SummarizeDatabaseInsightResourceUsageAggregation.SummarizeDatabaseInsightResourceUsageAggregation;
const SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = __importStar(require("./summarize-database-insight-resource-usage-trend-aggregation-collection"));
exports.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = SummarizeDatabaseInsightResourceUsageTrendAggregationCollection.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection;
const SummarizeDatabaseInsightResourceUtilizationInsightAggregation = __importStar(require("./summarize-database-insight-resource-utilization-insight-aggregation"));
exports.SummarizeDatabaseInsightResourceUtilizationInsightAggregation = SummarizeDatabaseInsightResourceUtilizationInsightAggregation.SummarizeDatabaseInsightResourceUtilizationInsightAggregation;
const SummarizeDatabaseInsightTablespaceUsageTrendAggregationCollection = __importStar(require("./summarize-database-insight-tablespace-usage-trend-aggregation-collection"));
exports.SummarizeDatabaseInsightTablespaceUsageTrendAggregationCollection = SummarizeDatabaseInsightTablespaceUsageTrendAggregationCollection.SummarizeDatabaseInsightTablespaceUsageTrendAggregationCollection;
const SummarizeExadataInsightResourceCapacityTrendAggregation = __importStar(require("./summarize-exadata-insight-resource-capacity-trend-aggregation"));
exports.SummarizeExadataInsightResourceCapacityTrendAggregation = SummarizeExadataInsightResourceCapacityTrendAggregation.SummarizeExadataInsightResourceCapacityTrendAggregation;
const SummarizeExadataInsightResourceCapacityTrendCollection = __importStar(require("./summarize-exadata-insight-resource-capacity-trend-collection"));
exports.SummarizeExadataInsightResourceCapacityTrendCollection = SummarizeExadataInsightResourceCapacityTrendCollection.SummarizeExadataInsightResourceCapacityTrendCollection;
const SummarizeExadataInsightResourceForecastTrendAggregation = __importStar(require("./summarize-exadata-insight-resource-forecast-trend-aggregation"));
exports.SummarizeExadataInsightResourceForecastTrendAggregation = SummarizeExadataInsightResourceForecastTrendAggregation.SummarizeExadataInsightResourceForecastTrendAggregation;
const SummarizeExadataInsightResourceForecastTrendCollection = __importStar(require("./summarize-exadata-insight-resource-forecast-trend-collection"));
exports.SummarizeExadataInsightResourceForecastTrendCollection = SummarizeExadataInsightResourceForecastTrendCollection.SummarizeExadataInsightResourceForecastTrendCollection;
const SummarizeExadataInsightResourceStatisticsAggregationCollection = __importStar(require("./summarize-exadata-insight-resource-statistics-aggregation-collection"));
exports.SummarizeExadataInsightResourceStatisticsAggregationCollection = SummarizeExadataInsightResourceStatisticsAggregationCollection.SummarizeExadataInsightResourceStatisticsAggregationCollection;
const SummarizeExadataInsightResourceUsageAggregation = __importStar(require("./summarize-exadata-insight-resource-usage-aggregation"));
exports.SummarizeExadataInsightResourceUsageAggregation = SummarizeExadataInsightResourceUsageAggregation.SummarizeExadataInsightResourceUsageAggregation;
const SummarizeExadataInsightResourceUsageCollection = __importStar(require("./summarize-exadata-insight-resource-usage-collection"));
exports.SummarizeExadataInsightResourceUsageCollection = SummarizeExadataInsightResourceUsageCollection.SummarizeExadataInsightResourceUsageCollection;
const SummarizeExadataInsightResourceUtilizationInsightAggregation = __importStar(require("./summarize-exadata-insight-resource-utilization-insight-aggregation"));
exports.SummarizeExadataInsightResourceUtilizationInsightAggregation = SummarizeExadataInsightResourceUtilizationInsightAggregation.SummarizeExadataInsightResourceUtilizationInsightAggregation;
const SummarizeHostInsightResourceCapacityTrendAggregationCollection = __importStar(require("./summarize-host-insight-resource-capacity-trend-aggregation-collection"));
exports.SummarizeHostInsightResourceCapacityTrendAggregationCollection = SummarizeHostInsightResourceCapacityTrendAggregationCollection.SummarizeHostInsightResourceCapacityTrendAggregationCollection;
const SummarizeHostInsightResourceForecastTrendAggregation = __importStar(require("./summarize-host-insight-resource-forecast-trend-aggregation"));
exports.SummarizeHostInsightResourceForecastTrendAggregation = SummarizeHostInsightResourceForecastTrendAggregation.SummarizeHostInsightResourceForecastTrendAggregation;
const SummarizeHostInsightResourceStatisticsAggregationCollection = __importStar(require("./summarize-host-insight-resource-statistics-aggregation-collection"));
exports.SummarizeHostInsightResourceStatisticsAggregationCollection = SummarizeHostInsightResourceStatisticsAggregationCollection.SummarizeHostInsightResourceStatisticsAggregationCollection;
const SummarizeHostInsightResourceUsageAggregation = __importStar(require("./summarize-host-insight-resource-usage-aggregation"));
exports.SummarizeHostInsightResourceUsageAggregation = SummarizeHostInsightResourceUsageAggregation.SummarizeHostInsightResourceUsageAggregation;
const SummarizeHostInsightResourceUsageTrendAggregationCollection = __importStar(require("./summarize-host-insight-resource-usage-trend-aggregation-collection"));
exports.SummarizeHostInsightResourceUsageTrendAggregationCollection = SummarizeHostInsightResourceUsageTrendAggregationCollection.SummarizeHostInsightResourceUsageTrendAggregationCollection;
const SummarizeHostInsightResourceUtilizationInsightAggregation = __importStar(require("./summarize-host-insight-resource-utilization-insight-aggregation"));
exports.SummarizeHostInsightResourceUtilizationInsightAggregation = SummarizeHostInsightResourceUtilizationInsightAggregation.SummarizeHostInsightResourceUtilizationInsightAggregation;
const SummarizeOperationsInsightsWarehouseResourceUsageAggregation = __importStar(require("./summarize-operations-insights-warehouse-resource-usage-aggregation"));
exports.SummarizeOperationsInsightsWarehouseResourceUsageAggregation = SummarizeOperationsInsightsWarehouseResourceUsageAggregation.SummarizeOperationsInsightsWarehouseResourceUsageAggregation;
const SummaryStatistics = __importStar(require("./summary-statistics"));
exports.SummaryStatistics = SummaryStatistics.SummaryStatistics;
const TablespaceUsageTrend = __importStar(require("./tablespace-usage-trend"));
exports.TablespaceUsageTrend = TablespaceUsageTrend.TablespaceUsageTrend;
const TablespaceUsageTrendAggregation = __importStar(require("./tablespace-usage-trend-aggregation"));
exports.TablespaceUsageTrendAggregation = TablespaceUsageTrendAggregation.TablespaceUsageTrendAggregation;
const UpdateAwrHubDetails = __importStar(require("./update-awr-hub-details"));
exports.UpdateAwrHubDetails = UpdateAwrHubDetails.UpdateAwrHubDetails;
const UpdateDatabaseInsightDetails = __importStar(require("./update-database-insight-details"));
exports.UpdateDatabaseInsightDetails = UpdateDatabaseInsightDetails.UpdateDatabaseInsightDetails;
const UpdateEnterpriseManagerBridgeDetails = __importStar(require("./update-enterprise-manager-bridge-details"));
exports.UpdateEnterpriseManagerBridgeDetails = UpdateEnterpriseManagerBridgeDetails.UpdateEnterpriseManagerBridgeDetails;
const UpdateExadataInsightDetails = __importStar(require("./update-exadata-insight-details"));
exports.UpdateExadataInsightDetails = UpdateExadataInsightDetails.UpdateExadataInsightDetails;
const UpdateHostInsightDetails = __importStar(require("./update-host-insight-details"));
exports.UpdateHostInsightDetails = UpdateHostInsightDetails.UpdateHostInsightDetails;
const UpdateOperationsInsightsWarehouseDetails = __importStar(require("./update-operations-insights-warehouse-details"));
exports.UpdateOperationsInsightsWarehouseDetails = UpdateOperationsInsightsWarehouseDetails.UpdateOperationsInsightsWarehouseDetails;
const UpdateOperationsInsightsWarehouseUserDetails = __importStar(require("./update-operations-insights-warehouse-user-details"));
exports.UpdateOperationsInsightsWarehouseUserDetails = UpdateOperationsInsightsWarehouseUserDetails.UpdateOperationsInsightsWarehouseUserDetails;
const UsageUnit = __importStar(require("./usage-unit"));
exports.UsageUnit = UsageUnit.UsageUnit;
const WorkRequest = __importStar(require("./work-request"));
exports.WorkRequest = WorkRequest.WorkRequest;
const WorkRequestCollection = __importStar(require("./work-request-collection"));
exports.WorkRequestCollection = WorkRequestCollection.WorkRequestCollection;
const WorkRequestError = __importStar(require("./work-request-error"));
exports.WorkRequestError = WorkRequestError.WorkRequestError;
const WorkRequestErrorCollection = __importStar(require("./work-request-error-collection"));
exports.WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
const WorkRequestLogEntry = __importStar(require("./work-request-log-entry"));
exports.WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
const WorkRequestLogEntryCollection = __importStar(require("./work-request-log-entry-collection"));
exports.WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
const WorkRequestResource = __importStar(require("./work-request-resource"));
exports.WorkRequestResource = WorkRequestResource.WorkRequestResource;
const WorkRequestResourceMetadataKey = __importStar(require("./work-request-resource-metadata-key"));
exports.WorkRequestResourceMetadataKey = WorkRequestResourceMetadataKey.WorkRequestResourceMetadataKey;
const WorkRequests = __importStar(require("./work-requests"));
exports.WorkRequests = WorkRequests.WorkRequests;
const AddEmManagedExternalExadataInsightMembersDetails = __importStar(require("./add-em-managed-external-exadata-insight-members-details"));
exports.AddEmManagedExternalExadataInsightMembersDetails = AddEmManagedExternalExadataInsightMembersDetails.AddEmManagedExternalExadataInsightMembersDetails;
const AutonomousDatabaseConfigurationSummary = __importStar(require("./autonomous-database-configuration-summary"));
exports.AutonomousDatabaseConfigurationSummary = AutonomousDatabaseConfigurationSummary.AutonomousDatabaseConfigurationSummary;
const AutonomousDatabaseInsight = __importStar(require("./autonomous-database-insight"));
exports.AutonomousDatabaseInsight = AutonomousDatabaseInsight.AutonomousDatabaseInsight;
const AutonomousDatabaseInsightSummary = __importStar(require("./autonomous-database-insight-summary"));
exports.AutonomousDatabaseInsightSummary = AutonomousDatabaseInsightSummary.AutonomousDatabaseInsightSummary;
const CreateEmManagedExternalDatabaseInsightDetails = __importStar(require("./create-em-managed-external-database-insight-details"));
exports.CreateEmManagedExternalDatabaseInsightDetails = CreateEmManagedExternalDatabaseInsightDetails.CreateEmManagedExternalDatabaseInsightDetails;
const CreateEmManagedExternalExadataInsightDetails = __importStar(require("./create-em-managed-external-exadata-insight-details"));
exports.CreateEmManagedExternalExadataInsightDetails = CreateEmManagedExternalExadataInsightDetails.CreateEmManagedExternalExadataInsightDetails;
const CreateEmManagedExternalHostInsightDetails = __importStar(require("./create-em-managed-external-host-insight-details"));
exports.CreateEmManagedExternalHostInsightDetails = CreateEmManagedExternalHostInsightDetails.CreateEmManagedExternalHostInsightDetails;
const CreateMacsManagedExternalHostInsightDetails = __importStar(require("./create-macs-managed-external-host-insight-details"));
exports.CreateMacsManagedExternalHostInsightDetails = CreateMacsManagedExternalHostInsightDetails.CreateMacsManagedExternalHostInsightDetails;
const CredentialsBySource = __importStar(require("./credentials-by-source"));
exports.CredentialsBySource = CredentialsBySource.CredentialsBySource;
const DBExternalInstance = __importStar(require("./d-bexternal-instance"));
exports.DBExternalInstance = DBExternalInstance.DBExternalInstance;
const DBExternalProperties = __importStar(require("./d-bexternal-properties"));
exports.DBExternalProperties = DBExternalProperties.DBExternalProperties;
const DBOSConfigInstance = __importStar(require("./d-bo-sconfig-instance"));
exports.DBOSConfigInstance = DBOSConfigInstance.DBOSConfigInstance;
const EmManagedExternalDatabaseConfigurationSummary = __importStar(require("./em-managed-external-database-configuration-summary"));
exports.EmManagedExternalDatabaseConfigurationSummary = EmManagedExternalDatabaseConfigurationSummary.EmManagedExternalDatabaseConfigurationSummary;
const EmManagedExternalDatabaseInsight = __importStar(require("./em-managed-external-database-insight"));
exports.EmManagedExternalDatabaseInsight = EmManagedExternalDatabaseInsight.EmManagedExternalDatabaseInsight;
const EmManagedExternalDatabaseInsightSummary = __importStar(require("./em-managed-external-database-insight-summary"));
exports.EmManagedExternalDatabaseInsightSummary = EmManagedExternalDatabaseInsightSummary.EmManagedExternalDatabaseInsightSummary;
const EmManagedExternalExadataInsight = __importStar(require("./em-managed-external-exadata-insight"));
exports.EmManagedExternalExadataInsight = EmManagedExternalExadataInsight.EmManagedExternalExadataInsight;
const EmManagedExternalExadataInsightSummary = __importStar(require("./em-managed-external-exadata-insight-summary"));
exports.EmManagedExternalExadataInsightSummary = EmManagedExternalExadataInsightSummary.EmManagedExternalExadataInsightSummary;
const EmManagedExternalHostConfigurationSummary = __importStar(require("./em-managed-external-host-configuration-summary"));
exports.EmManagedExternalHostConfigurationSummary = EmManagedExternalHostConfigurationSummary.EmManagedExternalHostConfigurationSummary;
const EmManagedExternalHostInsight = __importStar(require("./em-managed-external-host-insight"));
exports.EmManagedExternalHostInsight = EmManagedExternalHostInsight.EmManagedExternalHostInsight;
const EmManagedExternalHostInsightSummary = __importStar(require("./em-managed-external-host-insight-summary"));
exports.EmManagedExternalHostInsightSummary = EmManagedExternalHostInsightSummary.EmManagedExternalHostInsightSummary;
const EnableEmManagedExternalDatabaseInsightDetails = __importStar(require("./enable-em-managed-external-database-insight-details"));
exports.EnableEmManagedExternalDatabaseInsightDetails = EnableEmManagedExternalDatabaseInsightDetails.EnableEmManagedExternalDatabaseInsightDetails;
const EnableEmManagedExternalExadataInsightDetails = __importStar(require("./enable-em-managed-external-exadata-insight-details"));
exports.EnableEmManagedExternalExadataInsightDetails = EnableEmManagedExternalExadataInsightDetails.EnableEmManagedExternalExadataInsightDetails;
const EnableEmManagedExternalHostInsightDetails = __importStar(require("./enable-em-managed-external-host-insight-details"));
exports.EnableEmManagedExternalHostInsightDetails = EnableEmManagedExternalHostInsightDetails.EnableEmManagedExternalHostInsightDetails;
const EnableMacsManagedExternalHostInsightDetails = __importStar(require("./enable-macs-managed-external-host-insight-details"));
exports.EnableMacsManagedExternalHostInsightDetails = EnableMacsManagedExternalHostInsightDetails.EnableMacsManagedExternalHostInsightDetails;
const ExadataDatabaseMachineConfigurationSummary = __importStar(require("./exadata-database-machine-configuration-summary"));
exports.ExadataDatabaseMachineConfigurationSummary = ExadataDatabaseMachineConfigurationSummary.ExadataDatabaseMachineConfigurationSummary;
const ExadataDatabaseStatisticsSummary = __importStar(require("./exadata-database-statistics-summary"));
exports.ExadataDatabaseStatisticsSummary = ExadataDatabaseStatisticsSummary.ExadataDatabaseStatisticsSummary;
const ExadataDiskgroupStatisticsSummary = __importStar(require("./exadata-diskgroup-statistics-summary"));
exports.ExadataDiskgroupStatisticsSummary = ExadataDiskgroupStatisticsSummary.ExadataDiskgroupStatisticsSummary;
const ExadataHostStatisticsSummary = __importStar(require("./exadata-host-statistics-summary"));
exports.ExadataHostStatisticsSummary = ExadataHostStatisticsSummary.ExadataHostStatisticsSummary;
const ExadataStorageServerStatisticsSummary = __importStar(require("./exadata-storage-server-statistics-summary"));
exports.ExadataStorageServerStatisticsSummary = ExadataStorageServerStatisticsSummary.ExadataStorageServerStatisticsSummary;
const HostCpuHardwareConfiguration = __importStar(require("./host-cpu-hardware-configuration"));
exports.HostCpuHardwareConfiguration = HostCpuHardwareConfiguration.HostCpuHardwareConfiguration;
const HostCpuStatistics = __importStar(require("./host-cpu-statistics"));
exports.HostCpuStatistics = HostCpuStatistics.HostCpuStatistics;
const HostCpuUsage = __importStar(require("./host-cpu-usage"));
exports.HostCpuUsage = HostCpuUsage.HostCpuUsage;
const HostEntities = __importStar(require("./host-entities"));
exports.HostEntities = HostEntities.HostEntities;
const HostHardwareConfiguration = __importStar(require("./host-hardware-configuration"));
exports.HostHardwareConfiguration = HostHardwareConfiguration.HostHardwareConfiguration;
const HostImportableAgentEntitySummary = __importStar(require("./host-importable-agent-entity-summary"));
exports.HostImportableAgentEntitySummary = HostImportableAgentEntitySummary.HostImportableAgentEntitySummary;
const HostMemoryConfiguration = __importStar(require("./host-memory-configuration"));
exports.HostMemoryConfiguration = HostMemoryConfiguration.HostMemoryConfiguration;
const HostMemoryStatistics = __importStar(require("./host-memory-statistics"));
exports.HostMemoryStatistics = HostMemoryStatistics.HostMemoryStatistics;
const HostMemoryUsage = __importStar(require("./host-memory-usage"));
exports.HostMemoryUsage = HostMemoryUsage.HostMemoryUsage;
const HostNetworkActivitySummary = __importStar(require("./host-network-activity-summary"));
exports.HostNetworkActivitySummary = HostNetworkActivitySummary.HostNetworkActivitySummary;
const HostNetworkConfiguration = __importStar(require("./host-network-configuration"));
exports.HostNetworkConfiguration = HostNetworkConfiguration.HostNetworkConfiguration;
const HostProduct = __importStar(require("./host-product"));
exports.HostProduct = HostProduct.HostProduct;
const HostResourceAllocation = __importStar(require("./host-resource-allocation"));
exports.HostResourceAllocation = HostResourceAllocation.HostResourceAllocation;
const MacsManagedExternalDatabaseConfigurationSummary = __importStar(require("./macs-managed-external-database-configuration-summary"));
exports.MacsManagedExternalDatabaseConfigurationSummary = MacsManagedExternalDatabaseConfigurationSummary.MacsManagedExternalDatabaseConfigurationSummary;
const MacsManagedExternalDatabaseInsight = __importStar(require("./macs-managed-external-database-insight"));
exports.MacsManagedExternalDatabaseInsight = MacsManagedExternalDatabaseInsight.MacsManagedExternalDatabaseInsight;
const MacsManagedExternalDatabaseInsightSummary = __importStar(require("./macs-managed-external-database-insight-summary"));
exports.MacsManagedExternalDatabaseInsightSummary = MacsManagedExternalDatabaseInsightSummary.MacsManagedExternalDatabaseInsightSummary;
const MacsManagedExternalHostConfigurationSummary = __importStar(require("./macs-managed-external-host-configuration-summary"));
exports.MacsManagedExternalHostConfigurationSummary = MacsManagedExternalHostConfigurationSummary.MacsManagedExternalHostConfigurationSummary;
const MacsManagedExternalHostInsight = __importStar(require("./macs-managed-external-host-insight"));
exports.MacsManagedExternalHostInsight = MacsManagedExternalHostInsight.MacsManagedExternalHostInsight;
const MacsManagedExternalHostInsightSummary = __importStar(require("./macs-managed-external-host-insight-summary"));
exports.MacsManagedExternalHostInsightSummary = MacsManagedExternalHostInsightSummary.MacsManagedExternalHostInsightSummary;
const UpdateAutonomousDatabaseInsightDetails = __importStar(require("./update-autonomous-database-insight-details"));
exports.UpdateAutonomousDatabaseInsightDetails = UpdateAutonomousDatabaseInsightDetails.UpdateAutonomousDatabaseInsightDetails;
const UpdateEmManagedExternalDatabaseInsightDetails = __importStar(require("./update-em-managed-external-database-insight-details"));
exports.UpdateEmManagedExternalDatabaseInsightDetails = UpdateEmManagedExternalDatabaseInsightDetails.UpdateEmManagedExternalDatabaseInsightDetails;
const UpdateEmManagedExternalExadataInsightDetails = __importStar(require("./update-em-managed-external-exadata-insight-details"));
exports.UpdateEmManagedExternalExadataInsightDetails = UpdateEmManagedExternalExadataInsightDetails.UpdateEmManagedExternalExadataInsightDetails;
const UpdateEmManagedExternalHostInsightDetails = __importStar(require("./update-em-managed-external-host-insight-details"));
exports.UpdateEmManagedExternalHostInsightDetails = UpdateEmManagedExternalHostInsightDetails.UpdateEmManagedExternalHostInsightDetails;
const UpdateMacsManagedExternalDatabaseInsightDetails = __importStar(require("./update-macs-managed-external-database-insight-details"));
exports.UpdateMacsManagedExternalDatabaseInsightDetails = UpdateMacsManagedExternalDatabaseInsightDetails.UpdateMacsManagedExternalDatabaseInsightDetails;
const UpdateMacsManagedExternalHostInsightDetails = __importStar(require("./update-macs-managed-external-host-insight-details"));
exports.UpdateMacsManagedExternalHostInsightDetails = UpdateMacsManagedExternalHostInsightDetails.UpdateMacsManagedExternalHostInsightDetails;
//# sourceMappingURL=index.js.map