/**
 * UsageApi API
 * A description of the UsageApi API.
 * OpenAPI spec version: 20190111
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * It provides details about a product rewards and usage amount.
 */
export interface ProductSummary {
    /**
     * The ratecard product number.
     */
    "productNumber"?: string;
    /**
     * The ratecard product Name.
     */
    "productName"?: string;
    /**
     * The ratecard product usage amount. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "usageAmount"?: number;
    /**
     * The earned rewards for the product. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "earnedRewards"?: number;
    /**
     * The boolean flag to tell if the product is eligible for earning rewards.
     */
    "isEligibleToEarnRewards"?: boolean;
}
export declare namespace ProductSummary {
    function getJsonObj(obj: ProductSummary): object;
    function getDeserializedJsonObj(obj: ProductSummary): object;
}
